#include <iostream>
#include <stdio.h>
#include "fparser.hh"
#include <derivative.h>

using namespace std;

char fn[100],*deriv;



/*************** Functions for 2D ********************/


FunctionParser fp;
int res=fp.Parse(fn,"x");
FunctionParser fp_der;
int res2=fp_der.Parse(deriv,"x");

double deriv_pt(double* pt)                             //pass pointer to x coordinate
{
    double slope=fp_der.Eval(pt);
    return slope;
    }
char* eq_tangent(double* pt)                           //pass pointer to x coordinate
{
    char* eq=new char[100];
    double slope=fp_der.Eval(pt);
    double y=fp.Eval(pt);
    sprintf(eq,"y=%f+%f(x-%f)",y,slope,*pt);
    return eq;
}

char* eq_normal(double* pt)                            //pass pointer to x coordinate
{
      char* eq=new char[100];
    double slope=(-1)/(fp_der.Eval(pt));
    double y=fp.Eval(pt);
    sprintf(eq,"y=%f+%f(x-%f)",y,slope,*pt);
    return eq;
}


/*************** Functions for 3D ********************/


FunctionParser fp1;
int res3=fp1.Parse(fn,"x,y");

class gradient
{
    char *i,*j;
    FunctionParser gra_i,gra_j;

public:
gradient(char* f)                                  //f is the 3D function
 {i=deriv_fn(f,"x");
  j=deriv_fn(f,"y");
  gra_i.Parse(i,"x,y");
  gra_j.Parse(j,"x,y");}

double* val_at(double *vars)                       //vars is an array with 2 elements:x,y coordinate
{double* gra_val=new double[2];
 gra_val[0]=gra_i.Eval(vars);
 gra_val[1]=gra_j.Eval(vars);
return gra_val;
}

double dir_der(double *vars,double *dirn)            //vars is a 1D array with 2 elements:x,y coordinate
{                                                    //dirn is a 1D array with 2 ele v,u which give direction
double *grad=val_at(vars);
double l=sqrt(pow(dirn[0],2)+pow(dirn[1],2));
double res=grad[0]*dirn[0]/l+grad[1]*dirn[1]/l;
delete[] grad;
return res;
}

};

gradient grad(fn);


char* eq_normal3D(double* vars)                           //vars is an array with 2 elements:x,y coordinate
{
    double zval=fp1.Eval(vars);
    char* eq=new char[100];

    double* FxFy=grad.val_at(vars);
    double Fx=FxFy[0],Fy=FxFy[1];

    delete[] FxFy;
    sprintf(eq,"(%f-x)/%f=(%f-y)/%f=(z-(%f))",vars[0],Fx,vars[1],Fy,zval);
    return eq;
}
char* eq_TangentPlane(double* vars)                     //vars is an array with 2 elements:x,y coordinate
{
    double zval=fp1.Eval(vars);
    char* eq=new char[100];

    double* FxFy=grad.val_at(vars);
    double Fx=FxFy[0],Fy=FxFy[1];

    delete[] FxFy;

    double cons=zval-Fx*vars[0]-Fy*vars[1];

    sprintf(eq,"z=(%f)*x+(%f)*y+(%f)",Fx,Fy,cons);
    return eq;
}
/*****************************************************/
int main()
{


cout<<"give function : ";
cin>>fn;
deriv=deriv_fn(fn,"x");

delete[] deriv;

return 0;
}
