#include <iostream>
#include <fparser.hh>
#include <cstdio>
#include <cmath>
using namespace std;

double integrator(char func[],double h,double a,double b,double y)//integrating function
{
  FunctionParser fp;//fparser thing
  fp.Parse(func,"x,y");
  double fa_ih,fa_i_1h;
  double integral=0;
  double x;
  int negative=0;
  double accustrip=0.0001;//prameter for accuracy of the area of the strip
  if(a>b)
  {
      double tmp=b;
      b=a;
      a=tmp;
      negative=1;
  }

  for(x=a;x<b;x=x+h)//fa_ih===fx_h   fa_i_1h====fx_2h
  {

      double variable1[2]={x,y};
      double variable2[2]={x+h,y};
      fa_ih=fp.Eval(variable1);
      fa_i_1h=fp.Eval(variable2);
    if((x+h)>b)
      {
          integral=integral+integrator(func,(b-x),x,b,y);//considering the integral for the last strip of the curve for fitting perfectly
          break;
      }
      double fmid=(fa_ih+fa_i_1h)/2;//trapezoidal method
      if((abs(fmid-fa_ih))>=accustrip)//checking the accuracy of the area of strip
      {
          if(((abs(fmid-fa_ih))>=accustrip)&&((abs(fmid-fa_i_1h))>=accustrip))//if error is more than reduce h
          {
              integral=integral+integrator(func,h/2,x,x+h,y);//recursive calling
              continue;
          }
          integral=integral+integrator(func,h/2,x,(2*x+h)/2,y);
          continue;
      }
      if((abs(fmid-fa_i_1h))>=accustrip)
      {
          integral=integral+integrator(func,h/20,(2*x+h)/2,x+h,y);
          continue;
      }
        integral=integral+h*fmid;//summing up
    }
    if(negative==1)
    {
        return (-integral);
    }
    return integral;

}


double integratormain(char func[],double a,double b,double y)//main integrator to set value of h and pass it to integrator
{
  double h=0.0001;//width of strip
  double result=integrator(func,h,a,b,y);
  return result;
}







double doubleintegrator(char func[],double k,double ay,double by,double ax,double bx)//integrating function
{

  double areak,areak_1;
  double integral=0;
  double y;
  int negative=0;
  double accustrip=0.01;//prameter for accuracy of the area of the strip
  if(ay>by)
  {
      double tmp=by;
      by=ay;
      ay=tmp;
      negative=1;
  }

  for(y=ay;y<by;y=y+k)//fa_ih===fx_h   fa_i_1h====fx_2h
  {

      areak=integratormain(func,ax,bx,y);
      areak_1=integratormain(func,ax,bx,y+k);
      if((y+k)>by)
      {
          integral=integral+doubleintegrator(func,(by-y),y,by,ax,bx);//considering the integral for the last strip of the curve for fitting perfectly
          break;
      }
      double areamid=(areak+areak_1)/2;//trapezoidal method
      if((abs(areamid-areak))>=accustrip)//checking the accuracy of the area of strip
      {
          if(((abs(areamid-areak))>=accustrip)&&((abs(areamid-areak_1))>=accustrip))//if error is more than reduce h
          {
              integral=integral+doubleintegrator(func,k/2,y,y+k,ax,bx);//recursive calling
              continue;
          }
          integral=integral+doubleintegrator(func,k/2,y,(2*y+k)/2,ax,bx);
          continue;
      }
      if((abs(areamid-areak_1))>=accustrip)
      {
          integral=integral+doubleintegrator(func,k/2,(2*y+k)/2,y+k,ax,bx);
          continue;
      }
        integral=integral+k*areamid;//summing up
    }
    if(negative==1)
    {
        return (-integral);
    }
    return integral;

}


double doubleintegratormain(char func[],double ay,double by,double ax,double bx)//main integrator to set value of h and pass it to integrator
{
  double k=0.01;//width of strip
  double result=doubleintegrator(func,k,ay,by,ax,bx);
  return result;
}

