#include <iostream>
#include <fparser.hh>
#include <cstdio>
#include <cmath>
using namespace std;

double integrator(char func[],double h,double a,double b)//integrating function
{
  
  
  FunctionParser fp;//fparser thing
  fp.Parse(func,"x");
  double fa_ih,fa_i_1h;
  double integral=0;
  double x;
  int negative=0;
  if(a>b)
  {
      double tmp=b;
      b=a;
      a=tmp;
      negative=1;
  }

  for(x=a;x<b;x=x+h)//fa_ih===fx_h   fa_i_1h====fx_2h
  {
      double xv=x+h;
      double*xp=&x;double*xh=&xv;
      fa_ih=fp.Eval(xp);
      fa_i_1h=fp.Eval(xh);
      double accustrip=0.0001;//prameter for accuracy of the area of the strip
      if((x+h)>b)
      {
          integral=integral+integrator(func,(b-x),x,b);//considering the integral for the last strip of the curve for fitting perfectly
          break;
      }
      double fmid=(fa_ih+fa_i_1h)/2;//trapezoidal method
      if((abs(fmid-fa_ih))>=accustrip)//checking the accuracy of the area of strip
      {
          if(((abs(fmid-fa_ih))>=accustrip)&&((abs(fmid-fa_i_1h))>=accustrip))//if error is more than reduce h
          {
              integral=integral+integrator(func,h/2,x,x+h);//recursive calling
              continue;
          }
          integral=integral+integrator(func,h/2,x,(2*x+h)/2);
          continue;
      }
      if((abs(fmid-fa_i_1h))>=accustrip)
      {
          integral=integral+integrator(func,h/2,(2*x+h)/2,x+h);
          continue;
      }
        integral=integral+h*fmid;//summing up
    }
    if(negative==1)
    {
        return (-integral);
    }
    return integral;

}


double integratormain(char func[],double a,double b)//main integrator to set value of h and pass it to integrator
{
  double h=0.0001;//width of strip
  double result=integrator(func,h,a,b);
  return result;
}



